module mdy_shixu_ex2 (
    clk_in  ,
    rst_n   ,
    key     ,
    dout                         
    );

    input               clk_in  ;
    input               rst_n   ;
    input               key     ;

    output              dout    ;

    reg                 dout    ;
    wire                clk     ;
    reg   [28:0]        cnt     ;
    wire                add_cnt ;
    wire                end_cnt ;

    my_pll u_my_pll(
	            .inclk0(clk_in),
	            .c0    (clk   ),
	            .locked(      )
            );


    always @(posedge clk or negedge rst_n)begin
        if(!rst_n)begin
            cnt <= 0;
        end
        else if(add_cnt)begin
            if(end_cnt)
                cnt <= 0;
            else
                cnt <= cnt + 1;
        end
    end

    assign add_cnt = 1;       
    assign end_cnt = add_cnt && cnt==500_000_000-1 ;

    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            dout <= 0;
        end
        else if(end_cnt) begin
            dout <= ~dout;
        end
    end

endmodule

